; example.nsi
; Demonstrates (and mini test of) usage of untgz NSIS plugin
; KJD <jeremyd@computer.org>

; The name of the installer
Name "untgz Example"

; The file to write
OutFile "untgz_example.exe"

; Let user see messages in detail window
ShowInstDetails show

; The default installation directory
InstallDir $TEMP\Example

; The text to prompt the user to enter a directory
DirText "This will install the untgz example on your computer.  Please select a directory"

; The text to prompt the user to enter a directory
ComponentText "This will install untgz examples on your computer. Select which test to run."

; let user choose examples to run
InstType "All Examples"
InstType "extract all files"
InstType "extract all files alternate"
InstType "extract specific files"
InstType "extract a single file"
InstType "extract a corrupt or missing file"

; Required, the sample tarball used for testing
Section ""
  SectionIn 1 2 3 4 5 6 RO
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  ; Put file there
  File example.tgz
  File examplecorrupt.tgz
SectionEnd

Section "Test extract"
  SectionIn 1 2
  ; untgz::extract [-j] [-d basedir] tarball.tgz
  untgz::extract -j -d "$INSTDIR/junkedpaths" "$INSTDIR/example.tgz"
  untgz::extract -d "$INSTDIR/withpaths" "$INSTDIR/example.tgz"
SectionEnd

Section "Test extractV, same as extract"
  SectionIn 1 3
  ; untgz::extractV [-j] [-d basedir] tarball.tgz [-i {iList}] [-x {xList}] --
  untgz::extractV -j -d "$INSTDIR/junkedpathsAlt" "$INSTDIR/example.tgz" --
  untgz::extractV -d "$INSTDIR/withpathsAlt" "$INSTDIR/example.tgz" --
SectionEnd

Section "Test extractV"
  SectionIn 1 4
  ; untgz::extractV [-j] [-d basedir] tarball.tgz [-i {iList}] [-x {xList}] --
  untgz::extractV -j -d "$INSTDIR/junkedpathsI" "$INSTDIR/example.tgz" -i "another doc.txt" --
  untgz::extractV -j -d "$INSTDIR/junkedpathsX" "$INSTDIR/example.tgz" -x "another doc.txt" --
  untgz::extractV -d "$INSTDIR/withpathsI" "$INSTDIR/example.tgz" -i "another doc.txt" --
  untgz::extractV -d "$INSTDIR/withpathsX" "$INSTDIR/example.tgz" -x "another doc.txt" --
  untgz::extractV -d "$INSTDIR/withpathsX curious" "$INSTDIR/example.tgz" -x "subdir/*" --
SectionEnd

Section "Test extractFile"
  SectionIn 1 5
  ; untgz::extractFile [-d basedir] tarball.tgz file
  untgz::extractFile -d "$INSTDIR/singlefile" "$INSTDIR/example.tgz" "another doc.txt"
SectionEnd

Section "Test extract corrupt File"
  SectionIn 1 6
  ; attempt to extract from a corrupt [manually truncated] tarball
  untgz::extractFile -d "$INSTDIR/corrupt" "$INSTDIR/examplecorrupt.tgz" "fake doc.txt"

  ; attempt to extract from a nonexistant tarball
  untgz::extractFile -d "$INSTDIR/corrupt" "$INSTDIR/exampleNotExist.tgz" "my doc.txt"

  ; attempt a proper extraction, should succeed.
  untgz::extractFile -d "$INSTDIR/corruptSuccess" "$INSTDIR/example.tgz" "another doc.txt"
SectionEnd

; eof
